/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.8 Revision 1.143
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.8 2008/04/04 22:15:24 zlin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.143 2014/11/13 04:19:51 kensington Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPIs 4 and 5. This will be
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# reviewed over time as new EAPI versions are approved.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
17 18
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
19 25
20kde4-base_set_qt_dependencies() { 26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
21 local qt qtcore qtgui qt3support qtsvg qttest qtopengl qtdepend qtopengldepend 27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
22 29
23 # use dependencies 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
31# @DESCRIPTION:
32# For proper description see virtualx.eclass manpage.
33# Here we redefine default value to be manual, if your package needs virtualx
34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
35: ${VIRTUALX_REQUIRED:=manual}
36
37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
38
39if [[ ${KDE_BUILD_TYPE} = live ]]; then
40 case ${KDE_SCM} in
41 svn) inherit subversion ;;
42 git) inherit git-r3 ;;
43 esac
44fi
45
46# @ECLASS-VARIABLE: CMAKE_REQUIRED
47# @DESCRIPTION:
48# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
49# Please note that if it's set to 'never' you need to explicitly override following phases:
50# src_configure, src_compile, src_test and src_install.
51# Defaults to 'always'.
52: ${CMAKE_REQUIRED:=always}
53if [[ ${CMAKE_REQUIRED} = always ]]; then
54 buildsystem_eclass="cmake-utils"
55 export_fns="src_configure src_compile src_test src_install"
56fi
57
58# @ECLASS-VARIABLE: KDE_MINIMAL
59# @DESCRIPTION:
60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
61# version for apps to work. Currently defaults to 4.4
62# One may override this variable to raise version requirements.
63# Note that it is fixed to ${PV} for kde-base packages.
64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
65
66# Set slot for KDEBASE known packages
67case ${KDEBASE} in
68 kde-base)
24 case "${EAPI}" in 69 case ${EAPI} in
25 kdebuild-1) 70 5)
26 qt="[accessibility][dbus][debug?][gif][jpeg][png][qt3support][ssl][zlib]" 71 SLOT=4/$(get_version_component_range 1-2)
27 qtcore="[debug?][qt3support][ssl]"
28 qtgui="[accessibility][dbus][debug?]"
29 qt3support="[accessibility][debug?]"
30 qtsvg="[debug?]"
31 qttest="[debug?]"
32 qtopengl="[debug?]"
33 case "${OPENGL_REQUIRED}" in
34 always)
35 qt="${qt}[opengl]"
36 ;; 72 ;;
37 optional) 73 *)
38 qt="${qt}[opengl?]" 74 SLOT=4
39 ;; 75 ;;
40 esac 76 esac
77 KDE_MINIMAL="${PV}"
41 ;; 78 ;;
79 kdevelop)
80 if [[ ${KDE_BUILD_TYPE} = live ]]; then
81 # @ECLASS-VARIABLE: KDEVELOP_VERSION
82 # @DESCRIPTION:
83 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
84 # Applies to KDEBASE=kdevelop only.
85 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
86 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
87 # @DESCRIPTION:
88 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
89 # Applies to KDEBASE=kdevelop only.
90 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
91 else
92 case ${PN} in
93 kdevelop)
94 KDEVELOP_VERSION=${PV}
95 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
96 ;;
97 kdevplatform|kdevelop-php*|kdevelop-python)
98 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
99 KDEVPLATFORM_VERSION=${PV}
100 ;;
101 *)
102 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
103 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
104 esac
105 fi
106 SLOT="4"
107 ;;
42 esac 108esac
43 109
44 # split qt 110inherit ${buildsystem_eclass}
45 qtdepend="
46 x11-libs/qt-core:4${qtcore}
47 x11-libs/qt-gui:4${qtgui}
48 x11-libs/qt-qt3support:4${qt3support}
49 x11-libs/qt-svg:4${qtsvg}
50 x11-libs/qt-test:4${qttest}"
51 qtopengldepend="x11-libs/qt-opengl:4${qtopengl}"
52 111
53 # allow monolithic qt for PV < 4.1 112EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
54 case "${PV}" in
55 scm|9999.4|4.1*) : ;;
56 *)
57 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )"
58 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )"
59 ;;
60 esac
61 113
62 # opengl dependencies 114unset buildsystem_eclass
63 case "${OPENGL_REQUIRED}" in 115unset export_fns
64 always)
65 qtdepend="${qtdepend}
66 ${qtopengldepend}"
67 ;;
68 optional)
69 IUSE="${IUSE} opengl"
70 qtdepend="${qtdepend}
71 opengl? ( ${qtopengldepend} )"
72 ;;
73 *)
74 OPENGL_REQUIRED="never"
75 ;;
76 esac
77 116
78 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 117# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
79} 118# @DESCRIPTION:
80kde4-base_set_qt_dependencies 119# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
120# This variable must be set before inheriting any eclasses. Defaults to 'never'.
121DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
81 122
82DEPEND="${DEPEND} ${COMMONDEPEND} 123# @ECLASS-VARIABLE: QTHELP_REQUIRED
83 >=dev-util/cmake-2.4.7-r1 124# @DESCRIPTION:
84 dev-util/pkgconfig 125# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
85 x11-libs/libXt 126# This variable must be set before inheriting any eclasses. Defaults to 'never'.
86 x11-proto/xf86vidmodeproto" 127QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
87RDEPEND="${RDEPEND} ${COMMONDEPEND}"
88 128
89# @ECLASS-VARIABLE: OPENGL_REQUIRED 129# @ECLASS-VARIABLE: OPENGL_REQUIRED
90# @DESCRIPTION: 130# @DESCRIPTION:
91# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 131# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
92# This variable must be set before inheriting any eclasses. Defaults to 'never'. 132# This variable must be set before inheriting any eclasses. Defaults to 'never'.
93OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 133OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
134
135# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
136# @DESCRIPTION:
137# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
138# This variable must be set before inheriting any eclasses. Defaults to 'never'.
139MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
94 140
95# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 141# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
96# @DESCRIPTION: 142# @DESCRIPTION:
97# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 143# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
98# This variable must be set before inheriting any eclasses. Defaults to 'never'. 144# This variable must be set before inheriting any eclasses. Defaults to 'never'.
99CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 145CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
100 146
101case "${CPPUNIT_REQUIRED}" in 147# @ECLASS-VARIABLE: KDE_REQUIRED
148# @DESCRIPTION:
149# Is kde required? Possible values are 'always', 'optional' and 'never'.
150# This variable must be set before inheriting any eclasses. Defaults to 'always'
151# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
152# Note that for kde-base packages this variable is fixed to 'always'.
153KDE_REQUIRED="${KDE_REQUIRED:-always}"
154
155# @ECLASS-VARIABLE: KDE_HANDBOOK
156# @DESCRIPTION:
157# Set to enable handbook in application. Possible values are 'always', 'optional'
158# (handbook USE flag) and 'never'.
159# This variable must be set before inheriting any eclasses. Defaults to 'never'.
160# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
161# ensures buildtime and runtime dependencies.
162KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
163
164# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
165# @DESCRIPTION:
166# Set this varible if you want your live package to manage its
167# translations. (Mostly all kde ebuilds does not ship documentation
168# and translations in live ebuilds)
169if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
170 # Kdebase actualy provides the handbooks even for live stuff
171 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
172 KDE_LINGUAS=""
173fi
174
175# Setup packages inheriting this eclass
176case ${KDEBASE} in
177 kde-base)
178 HOMEPAGE="http://www.kde.org/"
179 LICENSE="GPL-2"
180 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
181 # Disable tests for live ebuilds by default
182 RESTRICT+=" test"
183 fi
184
185 # This code is to prevent portage from searching GENTOO_MIRRORS for
186 # packages that will never be mirrored. (As they only will ever be in
187 # the overlay).
188 case ${PV} in
189 *9999* | 4.?.[6-9]? | 4.??.[6-9]?)
190 RESTRICT+=" mirror"
191 ;;
192 esac
193 ;;
194 kdevelop)
195 HOMEPAGE="http://www.kdevelop.org/"
196 LICENSE="GPL-2"
197 ;;
198esac
199
200# @ECLASS-VARIABLE: QT_MINIMAL
201# @DESCRIPTION:
202# Determine version of qt we enforce as minimal for the package.
203QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
204
205# Declarative dependencies
206qtdeclarativedepend="
207 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
208"
209case ${DECLARATIVE_REQUIRED} in
102 always) 210 always)
103 DEPEND="${DEPEND} dev-util/cppunit" 211 COMMONDEPEND+=" ${qtdeclarativedepend}"
104 ;; 212 ;;
105 optional) 213 optional)
106 IUSE="${IUSE} test" 214 IUSE+=" declarative"
107 DEPEND="${DEPEND} 215 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
108 test? ( dev-util/cppunit )"
109 ;; 216 ;;
217 *) ;;
218esac
219unset qtdeclarativedepend
220
221# QtHelp dependencies
222qthelpdepend="
223 >=dev-qt/qthelp-${QT_MINIMAL}:4
224"
225case ${QTHELP_REQUIRED} in
226 always)
227 COMMONDEPEND+=" ${qthelpdepend}"
228 ;;
229 optional)
230 IUSE+=" qthelp"
231 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
232 ;;
233esac
234unset qthelpdepend
235
236# OpenGL dependencies
237qtopengldepend="
238 >=dev-qt/qtopengl-${QT_MINIMAL}:4
239"
240case ${OPENGL_REQUIRED} in
241 always)
242 COMMONDEPEND+=" ${qtopengldepend}"
243 ;;
244 optional)
245 IUSE+=" opengl"
246 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
247 ;;
248 *) ;;
249esac
250unset qtopengldepend
251
252# MultiMedia dependencies
253qtmultimediadepend="
254 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
255"
256case ${MULTIMEDIA_REQUIRED} in
257 always)
258 COMMONDEPEND+=" ${qtmultimediadepend}"
259 ;;
260 optional)
261 IUSE+=" multimedia"
262 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
263 ;;
264 *) ;;
265esac
266unset qtmultimediadepend
267
268# CppUnit dependencies
269cppuintdepend="
270 dev-util/cppunit
271"
272case ${CPPUNIT_REQUIRED} in
273 always)
274 DEPEND+=" ${cppuintdepend}"
275 ;;
276 optional)
277 IUSE+=" test"
278 DEPEND+=" test? ( ${cppuintdepend} )"
279 ;;
280 *) ;;
281esac
282unset cppuintdepend
283
284# KDE dependencies
285# Qt accessibility classes are needed in various places, bug 325461
286kdecommondepend="
287 dev-lang/perl
288 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
289 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
290 >=dev-qt/qtdbus-${QT_MINIMAL}:4
291 >=dev-qt/designer-${QT_MINIMAL}:4[-phonon]
292 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
293 >=dev-qt/qtscript-${QT_MINIMAL}:4
294 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
295 >=dev-qt/qtsvg-${QT_MINIMAL}:4
296 >=dev-qt/qttest-${QT_MINIMAL}:4
297 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
298"
299
300if [[ ${PN} != kdelibs ]]; then
301 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
302 if [[ ${KDEBASE} = kdevelop ]]; then
303 if [[ ${PN} != kdevplatform ]]; then
304 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
305 # @DESCRIPTION:
306 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
307 # Applies to KDEBASE=kdevelop only.
308 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
309 case ${KDEVPLATFORM_REQUIRED} in
310 always)
311 kdecommondepend+="
312 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
313 "
314 ;;
315 *) ;;
316 esac
317 fi
318 fi
319fi
320
321kdedepend="
322 dev-util/automoc
323 virtual/pkgconfig
324 !aqua? (
325 >=x11-libs/libXtst-1.1.0
326 x11-proto/xf86vidmodeproto
327 )
328"
329
330kderdepend=""
331
332# all packages needs oxygen icons for basic iconset
333if [[ ${PN} != oxygen-icons ]]; then
334 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
335fi
336
337# add a dependency over kde-l10n
338if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
339 for _lingua in ${KDE_LINGUAS}; do
340 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
341 # but only for selected ones.
342 # this can't be done on one line because if user doesn't use any localisation
343 # then he is probably not interested in kde-l10n at all.
344 kderdepend+="
345 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
346 "
347 done
348 unset _lingua
349fi
350
351kdehandbookdepend="
352 app-text/docbook-xml-dtd:4.2
353 app-text/docbook-xsl-stylesheets
354"
355kdehandbookrdepend="
356 $(add_kdebase_dep kdelibs 'handbook')
357"
358case ${KDE_HANDBOOK} in
359 always)
360 kdedepend+=" ${kdehandbookdepend}"
361 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
362 ;;
363 optional)
364 IUSE+=" +handbook"
365 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
366 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
367 ;;
368 *) ;;
369esac
370unset kdehandbookdepend kdehandbookrdepend
371
372case ${KDE_SELINUX_MODULE} in
373 none) ;;
110 *) 374 *)
111 CPPUNIT_REQUIRED="never" 375 IUSE+=" selinux"
376 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
112 ;; 377 ;;
113esac 378esac
114 379
115# @ECLASS-VARIABLE: NEED_KDE 380# We always need the aqua useflag because otherwise we cannot = refer to it inside
116# @DESCRIPTION: 381# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
117# This variable sets the version of KDE4 which will be used by the eclass. 382# (where referring to a use flag not in IUSE masks the ebuild).
118# This variable must be set by the ebuild, for all categories except for "kde-base". 383# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
119# For kde-base packages, if it is not set by the ebuild, 384IUSE+=" aqua"
120# it's assumed that the required KDE4 version is the latest, non-live, available.
121#
122# @CODE
123# Acceptable values are:
124# - latest - Use latest version in the portage tree
125# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice.
126# - svn - Use svn release (live ebuilds)
127# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
128# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
129# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
130# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
131# @CODE
132#
133# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
134# koffice, so you must set it explicitly in the ebuild, in all other cases.
135if [[ -z ${NEED_KDE} ]]; then
136 if [[ -n ${KDEBASE} ]]; then
137 NEED_KDE="latest"
138 else
139 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
140 fi
141fi
142export NEED_KDE
143 385
144case ${NEED_KDE} in 386case ${KDE_REQUIRED} in
145 latest) 387 always)
146 # Should only be used by 'kde-base'-ebuilds 388 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
147 if [[ "${KDEBASE}" == "kde-base" ]]; then 389 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
148 case ${PV} in 390 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
149 3.9*) _kdedir="3.9" ;;
150 4*) _kdedir="4.0" ;;
151 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
152 esac
153 _operator=">="
154 _pv="-${PV}:kde-4"
155 else
156 _kdedir="4.0"
157 _pv=":kde-4"
158 fi
159 ;; 391 ;;
160 scm|svn|9999*|:kde-svn) 392 optional)
161 _kdedir="svn" 393 IUSE+=" kde"
162 _pv=":kde-svn" 394 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
163 export NEED_KDE="svn" 395 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
396 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
164 ;; 397 ;;
165 *:kde-svn) 398 *) ;;
166 _kdedir="svn"
167 _operator=">="
168 _pv="-${NEED_KDE}"
169 export NEED_KDE="svn"
170 ;;
171 # The ebuild handles dependencies, KDEDIR, SLOT.
172 none)
173 :
174 ;;
175 # NEED_KDE=":${SLOT}"
176 :kde-4)
177 _kdedir="4.0"
178 _pv="${NEED_KDE}"
179 ;;
180 # NEED_KDE="${PV}:${SLOT}"
181 *:kde-4)
182 _kdedir="4.0"
183 _operator=">="
184 _pv="-${NEED_KDE}"
185 ;;
186 3.9*)
187 _kdedir="3.9"
188 _operator=">="
189 _pv="-${NEED_KDE}:kde-4"
190 ;;
191 4*)
192 _kdedir="4.0"
193 _operator=">="
194 _pv="-${NEED_KDE}:kde-4"
195 ;;
196 *) die "NEED_KDE=${NEED_KDE} currently not supported."
197 ;;
198esac 399esac
199 400
200if [[ ${NEED_KDE} != none ]]; then 401unset kdecommondepend kdedepend kderdepend
201 KDEDIR="/usr/kde/${_kdedir}"
202 KDEDIRS="/usr:/usr/local:${KDEDIR}"
203 402
204 if [[ -n ${KDEBASE} ]]; then 403debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
205 if [[ ${NEED_KDE} = svn ]]; then 404debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
206 SLOT="kde-svn" 405debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
207 else
208 SLOT="kde-4"
209 fi
210 fi
211 406
212 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 407# Accumulate dependencies set by this eclass
213 if [[ ${PN} != "kdelibs" ]]; then
214 DEPEND="${DEPEND} 408DEPEND+=" ${COMMONDEPEND}"
215 ${_operator}kde-base/kdelibs${_pv}"
216 RDEPEND="${RDEPEND} 409RDEPEND+=" ${COMMONDEPEND}"
217 ${_operator}kde-base/kdelibs${_pv}" 410unset COMMONDEPEND
218 if [[ ${PN} != "kdepimlibs" ]]; then
219 DEPEND="${DEPEND}
220 ${_operator}kde-base/kdepimlibs${_pv}"
221 RDEPEND="${RDEPEND}
222 ${_operator}kde-base/kdepimlibs${_pv}"
223 fi
224 fi
225
226 unset _operator _pv _kdedir
227fi
228 411
229# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 412# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
230# koffice ebuild, the URI should be set in the ebuild itself 413# kdevelop ebuild, the URI should be set in the ebuild itself
231if [[ -n ${KDEBASE} ]]; then 414_calculate_src_uri() {
415 debug-print-function ${FUNCNAME} "$@"
416
417 local _kmname _kmname_pv
418
419 # we calculate URI only for known KDEBASE modules
420 [[ -n ${KDEBASE} ]] || return
421
422 # calculate tarball module name
232 if [[ -n ${KMNAME} ]]; then 423 if [[ -n ${KMNAME} ]]; then
233 _kmname=${KMNAME} 424 _kmname="${KMNAME}"
234 else 425 else
235 _kmname=${PN} 426 _kmname=${PN}
236 fi 427 fi
237 _kmname_pv="${_kmname}-${PV}" 428 _kmname_pv="${_kmname}-${PV}"
238 if [[ ${NEED_KDE} != "svn" ]]; then
239 case ${KDEBASE} in 429 case ${KDEBASE} in
240 kde-base) 430 kde-base)
241 case ${PV} in 431 case ${PV} in
432 4.4.11.1)
433 # KDEPIM 4.4, special case
434 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
435 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
436 4.?.[6-9]? | 4.??.[6-9]?)
437 # Unstable KDE SC releases
438 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
439 4.[1-7].[12345])
440 # Stable KDE SC with old .bz2 support
242 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 441 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
442 4.11.9)
443 # Part of 4.12 actually, sigh. Not stable for next release!
444 SRC_URI="mirror://kde/stable/4.12.5/src/${_kmname_pv}.tar.xz" ;;
445 4.11.11)
446 # Part of 4.13 actually, sigh. Not stable for next release!
447 SRC_URI="mirror://kde/stable/4.13.3/src/${_kmname_pv}.tar.xz" ;;
448 4.11.12)
449 # Part of 4.14 actually, sigh. Not stable for next release!
450 SRC_URI="mirror://kde/stable/4.14.1/src/${_kmname_pv}.tar.xz" ;;
451 4.11.13)
452 # Part of 4.14 actually, sigh. Not stable for next release!
453 SRC_URI="mirror://kde/stable/4.14.2/src/${_kmname_pv}.tar.xz" ;;
454 4.11.14)
455 # Part of 4.14 actually, sigh. Not stable for next release!
456 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
457 *)
458 # Stable KDE SC releases
459 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
243 esac 460 esac
244 ;; 461 ;;
245 koffice) 462 kdevelop|kdevelop-php*|kdevplatform)
246 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 463 case ${KDEVELOP_VERSION} in
464 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
465 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
466 esac
247 ;; 467 ;;
468 esac
469}
470
471_calculate_live_repo() {
472 debug-print-function ${FUNCNAME} "$@"
473
474 SRC_URI=""
475 case ${KDE_SCM} in
476 svn)
477 # Determine branch URL based on live type
478 local branch_prefix
479 case ${PV} in
480 4.9999*)
481 # trunk
482 branch_prefix="trunk/KDE"
483 ;;
484 *)
485 # branch
486 branch_prefix="branches/KDE/$(get_kde_version)"
487 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
488 # @DESCRIPTION
489 # Suffix appended to ESVN_PROJECT depending on fetched branch.
490 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
491 ESVN_PROJECT_SUFFIX="-${PV}"
492 ;;
493 esac
494 # @ECLASS-VARIABLE: ESVN_MIRROR
495 # @DESCRIPTION:
496 # This variable allows easy overriding of default kde mirror service
497 # (anonsvn) with anything else you might want to use.
498 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
499 # Split ebuild, or extragear stuff
500 if [[ -n ${KMNAME} ]]; then
501 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
502 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
503 KMMODULE="${PN}"
504 fi
505 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
506 case ${KMNAME} in
507 kdebase-*)
508 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
509 ;;
510 kdelibs-*)
511 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
512 ;;
513 kdereview*)
514 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
515 ;;
516 kdesupport)
517 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
518 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
519 ;;
520 kde*)
521 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
522 ;;
523 extragear*|playground*)
524 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
525 # build packages from same svn location.
526 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
527 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
528 ;;
529 *)
530 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
531 ;;
532 esac
533 else
534 # kdelibs, kdepimlibs
535 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
536 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
537 fi
538 # @ECLASS-VARIABLE: ESVN_UP_FREQ
539 # @DESCRIPTION:
540 # This variable is used for specifying the timeout between svn synces
541 # for kde-base modules. Does not affect misc apps.
542 # Default value is 1 hour.
543 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
544 ;;
545 git)
546 local _kmname
547 # @ECLASS-VARIABLE: EGIT_MIRROR
548 # @DESCRIPTION:
549 # This variable allows easy overriding of default kde mirror service
550 # (anongit) with anything else you might want to use.
551 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
552
553 # @ECLASS-VARIABLE: EGIT_REPONAME
554 # @DESCRIPTION:
555 # This variable allows overriding of default repository
556 # name. Specify only if this differ from PN and KMNAME.
557 if [[ -n ${EGIT_REPONAME} ]]; then
558 # the repository and kmname different
559 _kmname=${EGIT_REPONAME}
560 elif [[ -n ${KMNAME} ]]; then
561 _kmname=${KMNAME}
562 else
563 _kmname=${PN}
564 fi
565
566 # default branching
567 [[ ${PV} != 4.9999* && ${KDEBASE} == kde-base ]] && \
568 EGIT_BRANCH="KDE/$(get_kde_version)"
569
570 # default repo uri
571 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
572
573 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
574 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
575 ;;
576 esac
577}
578
579case ${KDE_BUILD_TYPE} in
580 live) _calculate_live_repo ;;
581 *) _calculate_src_uri ;;
582esac
583
584debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
585
586# @ECLASS-VARIABLE: PREFIX
587# @DESCRIPTION:
588# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
589# kde-base packages go into KDE4 installation directory (/usr).
590# No matter the PREFIX, package will be built against KDE installed in /usr.
591
592# @FUNCTION: kde4-base_pkg_setup
593# @DESCRIPTION:
594# Do some basic settings
595kde4-base_pkg_setup() {
596 debug-print-function ${FUNCNAME} "$@"
597
598 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
599 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
600 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
601 fi
602
603 # Don't set KDEHOME during compilation, it will cause access violations
604 unset KDEHOME
605
606 # Check if gcc compiler is fresh enough.
607 # In theory should be in pkg_pretend but we check it only for kdelibs there
608 # and for others we do just quick scan in pkg_setup because pkg_pretend
609 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
610 if [[ ${MERGE_TYPE} != binary ]]; then
611 [[ $(gcc-major-version) -lt 4 ]] || \
612 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
613 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
614 fi
615
616 KDEDIR=/usr
617 : ${PREFIX:=/usr}
618 EKDEDIR=${EPREFIX}/usr
619
620 # Point to correct QT plugins path
621 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
622
623 # Fix XDG collision with sandbox
624 export XDG_CONFIG_HOME="${T}"
625}
626
627# @FUNCTION: kde4-base_src_unpack
628# @DESCRIPTION:
629# This function unpacks the source tarballs for KDE4 applications.
630kde4-base_src_unpack() {
631 debug-print-function ${FUNCNAME} "$@"
632
633 if [[ ${KDE_BUILD_TYPE} = live ]]; then
634 case ${KDE_SCM} in
635 svn)
636 subversion_src_unpack
637 ;;
638 git)
639 git-r3_src_unpack
640 ;;
248 esac 641 esac
249 fi
250 unset _kmname _kmname_pv
251fi
252
253debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
254debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
255
256# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
257# If KMNAME is not set then this is not a split package
258if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
259 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
260 DEPEND="${DEPEND} !${_x}:${SLOT}"
261 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
262 done
263 unset _x
264fi
265
266debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
267
268# @ECLASS-VARIABLE: PREFIX
269# @DESCRIPTION:
270# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
271# Applications installed by the other ebuilds go into /usr/ by default, this value
272# can be superseded by defining PREFIX before inheriting kde4-base.
273if [[ -n ${KDEBASE} ]]; then
274 PREFIX=${KDEDIR}
275else
276 # if PREFIX is not defined we set it to the default value of /usr
277 PREFIX="${PREFIX:-/usr}"
278fi
279
280debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
281
282# @FUNCTION: kde4-base_pkg_setup
283# @DESCRIPTION:
284# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
285# kde4-functions_check_use from kde4-functions.eclass to print appropriate
286# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
287# $KDE4_BUILT_WITH_USE_CHECK are missing.
288kde4-base_pkg_setup() {
289 debug-print-function $FUNCNAME "$@"
290
291 case "${EAPI}" in
292 kdebuild-1)
293 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK} ]] && \
294 die "built_with_use illegal in this EAPI!"
295 ;;
296 *)
297 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
298 if has_version '<x11-libs/qt-4.4_alpha:4'; then
299 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
300 else 642 else
301 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 643 unpack ${A}
302 x11-libs/qt-core qt3support ssl
303 x11-libs/qt-gui accessibility dbus
304 x11-libs/qt-qt3support accessibility"
305 fi 644 fi
306
307 if has debug ${IUSE//+} && use debug; then
308 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
309 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} debug"
310 else
311 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK}
312 x11-libs/qt-core:4 debug
313 x11-libs/qt-gui:4 debug
314 x11-libs/qt-qt3support:4 debug
315 x11-libs/qt-svg:4 debug
316 x11-libs/qt-test:4 debug"
317 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
318 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK}
319 x11-libs/qt-opengl:4 debug"
320 fi
321 fi
322 fi
323
324 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
325 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
326 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
327 fi
328 fi
329 kde4-functions_check_use
330 ;;
331 esac
332} 645}
333 646
334# @FUNCTION: kde4-base_apply_patches
335# @DESCRIPTION:
336# This function applies patches.
337#
338# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
339# directory, provided they follow this format:
340# @CODE
341# - Monolithic ebuilds, (from kde-base)
342# - $CATEGORY=kde-base:
343# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
344# - $CATEGORY=!kde-base:
345# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
346# - Split ebuilds:
347# - $CATEGORY=kde-base:
348# Apply ${PN}-${SLOT}-*{diff,patch}
349# - $CATEGORY!=kde-base:
350# Apply ${PN}-${PV}-*{diff,patch}
351# @CODE
352#
353# If ${PATCHES} is non-zero all patches in it get applied. If there is more
354# than one patch please make ${PATCHES} an array for proper quoting.
355kde4-base_apply_patches() {
356 local _patchdir _packages _p
357 _patchdir="${WORKDIR}/patches/"
358 if [[ -d "${_patchdir}" ]]; then
359 if is-parent-package ${CATEGORY}/${PN} ; then
360 _packages="$(get-child-packages ${CATEGORY}/${PN})"
361 _packages="${_packages//${CATEGORY}\//} ${PN}"
362 else
363 _packages="${PN}"
364 fi
365 if [[ ${#PATCHES[@]} -gt 1 ]]; then
366 for _p in ${_packages}; do
367 PATCHES=( "${PATCHES[@]}" $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null) )
368 if [[ -n "${KDEBASE}" ]]; then
369 PATCHES=( "${PATCHES[@]}" $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null) )
370 fi
371 done
372 else
373 for _p in ${_packages}; do
374 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null)"
375 if [[ -n "${KDEBASE}" ]]; then
376 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null)"
377 fi
378 done
379 fi
380 fi
381 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
382}
383
384# @FUNCTION: kde4-base_src_unpack 647# @FUNCTION: kde4-base_src_prepare
385# @DESCRIPTION: 648# @DESCRIPTION:
386# This function unpacks the source tarballs for KDE4 applications. 649# General pre-configure and pre-compile function for KDE4 applications.
387#
388# If no argument is passed to this function, then standard src_unpack is
389# executed. Otherwise options are passed to base_src_unpack.
390#
391# In addition it calls kde4-base_apply_patches when no arguments are passed to
392# this function.
393#
394# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 650# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
651# enable_selected_linguas() and enable_selected_doc_linguas()
395# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 652# in kde4-functions.eclass(5) for further details.
396kde4-base_src_unpack() { 653kde4-base_src_prepare() {
397 debug-print-function $FUNCNAME "$@" 654 debug-print-function ${FUNCNAME} "$@"
398 655
399 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 656 # enable handbook and linguas only when not using live ebuild
400
401 if [[ -z $* ]]; then
402 # Unpack first and deal with KDE patches after examing possible patch sets.
403 # To be picked up, patches need to conform to the guidelines stated before.
404 # Monolithic ebuilds will use the split ebuild patches.
405 [[ -d "${KDE_S}" ]] || unpack ${A}
406 kde4-base_apply_patches
407 else
408 # Call base_src_unpack, which unpacks and patches
409 # step by step transparently as defined in the ebuild.
410 base_src_unpack $*
411 fi
412
413 # Updated cmake dir
414 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
415 ebegin "Updating cmake/ directory..."
416 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
417 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
418 eend 0
419 fi
420 657
421 # Only enable selected languages, used for KDE extragear apps. 658 # Only enable selected languages, used for KDE extragear apps.
422 if [[ -n ${KDE_LINGUAS} ]]; then 659 if [[ -n ${KDE_LINGUAS} ]]; then
423 enable_selected_linguas 660 enable_selected_linguas
424 fi 661 fi
662
663 # Enable/disable handbooks for kde4-base packages
664 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
665 # kdelibs inherits kde4-base but handle installing the handbook itself
666 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
667 if [[ ${KDEBASE} == kde-base ]]; then
668 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
669 # documentation in kde4-functions
670 : ${KDE_DOC_DIRS:=doc}
671 local dir
672 for dir in ${KDE_DOC_DIRS}; do
673 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
674 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
675 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
676 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
677 -i CMakeLists.txt || die "failed to comment out handbook"
678 done
679 fi
680 else
681 enable_selected_doc_linguas
682 fi
683 fi
684
685 # SCM bootstrap
686 if [[ ${KDE_BUILD_TYPE} = live ]]; then
687 case ${KDE_SCM} in
688 svn) subversion_src_prepare ;;
689 esac
690 fi
691
692 # Apply patches, cmake-utils does the job already
693 cmake-utils_src_prepare
694
695 # Save library dependencies
696 if [[ -n ${KMSAVELIBS} ]] ; then
697 save_library_dependencies
698 fi
699
700 # Inject library dependencies
701 if [[ -n ${KMLOADLIBS} ]] ; then
702 load_library_dependencies
703 fi
704
705 # Hack for manuals relying on outdated DTD, only outside kde-base/...
706 if [[ -z ${KDEBASE} ]]; then
707 find "${S}" -name "*.docbook" \
708 -exec sed -i -r \
709 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
710 || die 'failed to fix DocBook variant version'
711 fi
712}
713
714# @FUNCTION: kde4-base_src_configure
715# @DESCRIPTION:
716# Function for configuring the build of KDE4 applications.
717kde4-base_src_configure() {
718 debug-print-function ${FUNCNAME} "$@"
719
720 # Build tests in src_test only, where we override this value
721 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
722
723 if use_if_iuse debug; then
724 # Set "real" debug mode
725 CMAKE_KDE_BUILD_TYPE="Debugfull"
726 else
727 # Handle common release builds
728 append-cppflags -DQT_NO_DEBUG
729 fi
730
731 # Set distribution name
732 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
733
734 # Here we set the install prefix
735 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
736
737 # Use colors
738 QTEST_COLORED=1
739
740 # Shadow existing installations
741 unset KDEDIRS
742
743 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
744 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
745 #kde-config -path data unavailable when cross-compiling
746 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
747
748 # sysconf needs to be /etc, not /usr/etc
749 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
750
751 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
752 if [[ ${mycmakeargs} ]]; then
753 eqawarn "mycmakeargs should always be declared as an array, not a string"
754 fi
755 mycmakeargs=(${mycmakeargs})
756 fi
757
758 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
759
760 cmake-utils_src_configure
425} 761}
426 762
427# @FUNCTION: kde4-base_src_compile 763# @FUNCTION: kde4-base_src_compile
428# @DESCRIPTION: 764# @DESCRIPTION:
429# General function for compiling KDE4 applications. 765# General function for compiling KDE4 applications.
430kde4-base_src_compile() { 766kde4-base_src_compile() {
431 debug-print-function ${FUNCNAME} "$@" 767 debug-print-function ${FUNCNAME} "$@"
432 768
433 kde4-base_src_configure
434 kde4-base_src_make
435}
436
437# @FUNCTION: kde4-base_src_configure
438# @DESCRIPTION:
439# Function for configuring the build of KDE4 applications.
440kde4-base_src_configure() {
441 debug-print-function ${FUNCNAME} "$@"
442
443 # Final flag handling
444 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
445 echo "Activating enable-final flag"
446 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
447 fi
448
449 # Enable generation of HTML handbook
450 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
451 echo "Enabling building of HTML handbook"
452 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
453 fi
454
455 # Build tests in src_test only, where we override this value
456 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
457
458 # Set distribution name
459 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
460
461 # runpath linking
462 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
463
464 # Here we set the install prefix
465 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
466
467 # Set environment
468 QTEST_COLORED=1
469 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
470
471 cmake-utils_src_configureout
472}
473
474# @FUNCTION: kde4-base_src_make
475# @DESCRIPTION:
476# Function for building KDE4 applications.
477# Options are passed to cmake-utils_src_make.
478kde4-base_src_make() {
479 debug-print-function ${FUNCNAME} "$@"
480
481 cmake-utils_src_make "$@" 769 cmake-utils_src_compile "$@"
482} 770}
483 771
484# @FUNCTION: kde4-base_src_test 772# @FUNCTION: kde4-base_src_test
485# @DESCRIPTION: 773# @DESCRIPTION:
486# Function for testing KDE4 applications. 774# Function for testing KDE4 applications.
487kde4-base_src_test() { 775kde4-base_src_test() {
488 debug-print-function ${FUNCNAME} "$@" 776 debug-print-function ${FUNCNAME} "$@"
489 777
778 local kded4_pid
779
780 _test_runner() {
781 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
782 export $(dbus-launch)
783 kded4 2>&1 > /dev/null &
784 kded4_pid=$!
785 fi
786
787 cmake-utils_src_test
788 }
789
790 # When run as normal user during ebuild development with the ebuild command, the
791 # kde tests tend to access the session DBUS. This however is not possible in a real
792 # emerge or on the tinderbox.
793 # > make sure it does not happen, so bad tests can be recognized and disabled
794 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
795
490 # Override this value, set in kde4-base_src_configure() 796 # Override this value, set in kde4-base_src_configure()
491 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 797 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
492 cmake-utils_src_compile 798 cmake-utils_src_configure
799 kde4-base_src_compile
493 800
494 cmake-utils_src_test 801 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
802 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
803 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
804 # surprise- we are already INSIDE virtualmake!!!
805 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
806 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
807 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
808 debug-print " kde4-base.eclass docs for details... Applying workaround."
809 _test_runner
810 else
811 VIRTUALX_COMMAND="_test_runner" virtualmake
812 fi
813 else
814 _test_runner
815 fi
816
817 if [ -n "${kded4_pid}" ] ; then
818 kill ${kded4_pid}
819 fi
820
821 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
822 kill ${DBUS_SESSION_BUS_PID}
823 fi
495} 824}
496 825
497# @FUNCTION: kde4-base_src_install 826# @FUNCTION: kde4-base_src_install
498# @DESCRIPTION: 827# @DESCRIPTION:
499# Function for installing KDE4 applications. 828# Function for installing KDE4 applications.
500kde4-base_src_install() { 829kde4-base_src_install() {
501 debug-print-function ${FUNCNAME} "$@" 830 debug-print-function ${FUNCNAME} "$@"
502 831
503 kde4-base_src_make_doc 832 if [[ -n ${KMSAVELIBS} ]] ; then
833 install_library_dependencies
834 fi
835
836 # Install common documentation of KDE4 applications
837 local doc
838 if ! has kde4-meta ${INHERITED}; then
839 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
840 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
841 done
842 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
843 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
844 done
845 fi
846
504 cmake-utils_src_install 847 cmake-utils_src_install
505}
506 848
507# @FUNCTION: kde4-base_src_make_doc 849 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
508# @DESCRIPTION: 850 # because then khelpcenter can't find the docs
509# Function for installing the documentation of KDE4 applications. 851 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
510kde4-base_src_make_doc() { 852 docompress -x ${PREFIX}/share/doc/HTML
511 debug-print-function ${FUNCNAME} "$@" 853}
512 854
513 local doc 855# @FUNCTION: kde4-base_pkg_preinst
514 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 856# @DESCRIPTION:
515 [[ -s $doc ]] && dodoc ${doc} 857# Function storing icon caches
516 done 858kde4-base_pkg_preinst() {
859 debug-print-function ${FUNCNAME} "$@"
517 860
518 if [[ -z ${KMNAME} ]]; then 861 gnome2_icon_savelist
519 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 862 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
520 if [[ -s $doc ]]; then 863 subversion_pkg_preinst
521 local doc_complete=${doc}
522 doc="${doc#*/}"
523 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
524 fi
525 done
526 fi
527
528 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
529 # work around bug #97196
530 dodir /usr/share/doc/kde && \
531 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
532 die "Failed to move docs to kde/ failed."
533 fi 864 fi
534} 865}
535 866
536# @FUNCTION: kde4-base_pkg_postinst 867# @FUNCTION: kde4-base_pkg_postinst
537# @DESCRIPTION: 868# @DESCRIPTION:
538# Function to rebuild the KDE System Configuration Cache after an application has been installed. 869# Function to rebuild the KDE System Configuration Cache after an application has been installed.
539kde4-base_pkg_postinst() { 870kde4-base_pkg_postinst() {
871 debug-print-function ${FUNCNAME} "$@"
872
873 gnome2_icon_cache_update
874 fdo-mime_desktop_database_update
875 fdo-mime_mime_database_update
540 buildsycoca 876 buildsycoca
877
878 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
879 if [[ ${KDE_BUILD_TYPE} = live ]]; then
880 echo
881 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
882 einfo "Use it at your own risk."
883 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
884 echo
885 fi
886 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
887 if [[ ${KDEBASE} != kde-base ]] && \
888 ! has_version 'kde-base/kdebase-runtime-meta' && \
889 ! has_version 'kde-base/kdebase-startkde'; then
890 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
891 echo
892 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
893 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
894 ewarn "With this setting you are unsupported by KDE team."
895 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
896 fi
897 fi
898 fi
541} 899}
542 900
543# @FUNCTION: kde4-base_pkg_postrm 901# @FUNCTION: kde4-base_pkg_postrm
544# @DESCRIPTION: 902# @DESCRIPTION:
545# Function to rebuild the KDE System Configuration Cache after an application has been removed. 903# Function to rebuild the KDE System Configuration Cache after an application has been removed.
546kde4-base_pkg_postrm() { 904kde4-base_pkg_postrm() {
905 debug-print-function ${FUNCNAME} "$@"
906
907 gnome2_icon_cache_update
908 fdo-mime_desktop_database_update
909 fdo-mime_mime_database_update
547 buildsycoca 910 buildsycoca
548} 911}
912
913fi

Legend:
Removed from v.1.8  
changed lines
  Added in v.1.143

  ViewVC Help
Powered by ViewVC 1.1.20